﻿<%
;(function(){
	/* 扩展字符串删除头尾空格（包括UTF8中的BOM字符） */
	String.prototype.trim		= function(){ return this.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"") };
	String.prototype.ltrim		= function(){ return this.replace(/^[\s\uFEFF\xA0]+/g,"") };
	String.prototype.rtrim		= function(){ return this.replace(/[\s\uFEFF\xA0]+$/g,"") };

	/* 对某字符串重复指定的次数 */
	String.prototype.repeat		= function(num){ return new Array(num+1).join(this) };

	/* 将一个字符串用padchar补齐至num位(num大于该字符串的长度) */
	String.prototype.padLeft	= function(padchar, num){ return padchar.repeat(this.length>num?0:(num-this.length)) + this };
	String.prototype.padRight	= function(padchar, num){ return this + padchar.repeat(this.length>num?0:(num-this.length)) };

	/* 字符串转为整型 */
	String.prototype.toInt		= function(){ if(isNaN(this)) return 0; else return parseInt(this,10) };

	/* 按指定长度截取字符串(默认的left函数指定长度不能大于总长度) */
	String.prototype.left		= function (n){ return this.substr(0,n) };
	String.prototype.right		= function (n){ return this.substr(this.length-n) };

	/* 格式化字符串 */
	String.prototype.format		= function(){ var a=arguments;return this.replace(/{(\d+)}/g, function(m,i){ return a[i]}) };

	/* 判断字符串以某子字符串开头或结尾 */
	String.prototype.startWith	= function(s){ return this.indexOf(s)==0 };
	String.prototype.endWith	= function(s){ return this.length-s.length>=0 && this.lastIndexOf(s)==this.length-s.length };
	String.prototype.contain	= function(s){ return this.indexOf(s)!=-1 };

	/* 将某字符串添加到本字符串结尾，但不重复添加 */
	String.prototype.addEnd		= function(s){ return this.endWith(s) ? this : this+s };

	/* 字节长度（汉字等占2个字节） */
	String.prototype.byteLength = function(){ return this.replace(/[^\x00-\xff]/g,"**").length }; 

    /* 按字节来截取长度 */
	String.prototype.byteLeft	= function (n) {
		var str = this;
		while (str.byteLength() > n) str = str.left(str.length-1);
		return str;
	};

	/* SQL防注入安全处理 */
	String.prototype.FixSql = function(){ return this.replace(/'/g,"&#39;").replace(/--/g,"&#45;&#45;") }

	/* 过滤html标记（以<开头并且<后紧接字母或/字母，至>结束的内容为HTML标记） */
	String.prototype.FilterHtml = function(){ return this.replace(/<\/?[a-z][^<>]*>/ig,"").replace(/&[a-z]+;/gi,"") }

	/*
		过滤特殊字符，holdChars为需要保留的特殊字符集，留空则只保留英文数字和汉字
		用法举例："发生!（1!@23/_ab'c-￥".FilterSpeChar("-_")  返回 "发生123_abc-"
	*/
	String.prototype.FilterSpeChar = function(holdChars){
		return this.replace(/[^0-9a-z\u4e00-\u9fa5]/ig,function(c){return (holdChars||"").indexOf(c)!=-1 ? c : ""});
	}

	/* 
		将字符串中的全角数字替换为半角数字
		因为MSSQL查询中全角数字会等同于半角数字
		测试 select getdate() where '５'='5' 为真
	*/
	String.prototype.fixNumber = function(){ 
		return this.replace(/[\uff10-\uff19]/ig,function($0){return "０１２３４５６７８９".indexOf($0).toString()});
	}

	/*
		将含有模板的字符串替换为实际内容（模拟ecma6新特性）
		用法："用户名为${user.name}".tpl() 输出 "用户名为张三"
	*/
	String.prototype.tpl		= function(v){ return this.replace(/\${([^{}]+)}/g, function(a,b){ try{return eval(b)||""}catch(e){return ""} }) };

	/**
	*	替换前后指定字符
	*	例: 
	*		|1|2| ==》 1|2       replaceStarEndChar("|","")
	*		1,2,3, ==> 1,2,3	 replaceStarEndChar(",","")
	*/	
	String.prototype.replaceStarEndChar = function (thischar,repval){		
		var soucestr = this; 		
		if(soucestr==(thischar+thischar)) return ""; // 只有字符时
		if(soucestr.startWith(thischar)) soucestr = repval+soucestr.substring(1); // 开头字符
		if(soucestr.endWith(thischar)) soucestr = soucestr.substring(0,soucestr.length-1)+repval; // 结束字符
		return soucestr.toString();
	}

	// html实体类转义成正常字符
	// 测试url:http://tool.oschina.net/commons?type=2
	String.prototype.htmlEntityDecode = function(){
		try{
			var obj = newChilkat950("Charset");			
			return obj.HtmlDecodeToStr(this);
		}catch(e){
			return "";
		}
	}


}());
%>